"""
    Agilicus API

    Agilicus is API-first. Modern software is controlled by other software, is open, is available for you to use the way you want, securely, simply.  The OpenAPI Specification in YAML format is available on [www](https://www.agilicus.com/www/api/agilicus-openapi.yaml) for importing to other tools.  A rendered, online viewable and usable version of this specification is available at [api](https://www.agilicus.com/api). You may try the API inline directly in the web page. To do so, first obtain an Authentication Token (the simplest way is to install the Python SDK, and then run `agilicus-cli --issuer https://MYISSUER get-token`). You will need an org-id for most calls (and can obtain from `agilicus-cli --issuer https://MYISSUER list-orgs`). The `MYISSUER` will typically be `auth.MYDOMAIN`, and you will see it as you sign-in to the administrative UI.  This API releases on Bearer-Token authentication. To obtain a valid bearer token you will need to Authenticate to an Issuer with OpenID Connect (a superset of OAUTH2).  Your \"issuer\" will look like https://auth.MYDOMAIN. For example, when you signed-up, if you said \"use my own domain name\" and assigned a CNAME of cloud.example.com, then your issuer would be https://auth.cloud.example.com.  If you selected \"use an Agilicus supplied domain name\", your issuer would look like https://auth.myorg.agilicus.cloud.  For test purposes you can use our [Python SDK](https://pypi.org/project/agilicus/) and run `agilicus-cli --issuer https://auth.MYDOMAIN get-token`.  This API may be used in any language runtime that supports OpenAPI 3.0, or, you may use our [Python SDK](https://pypi.org/project/agilicus/), our [Typescript SDK](https://www.npmjs.com/package/@agilicus/angular), or our [Golang SDK](https://git.agilicus.com/pub/sdk-go).  100% of the activities in our system our API-driven, from our web-admin, through our progressive web applications, to all internals: there is nothing that is not accessible.  For more information, see [developer resources](https://www.agilicus.com/developer).   # noqa: E501

    The version of the OpenAPI document: 2025.06.26
    Contact: dev@agilicus.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from agilicus_api.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)
from ..model_utils import OpenApiModel
from agilicus_api.exceptions import ApiAttributeError


def lazy_import():
    from agilicus_api.model.extra_process import ExtraProcess
    from agilicus_api.model.interceptor_config import InterceptorConfig
    globals()['ExtraProcess'] = ExtraProcess
    globals()['InterceptorConfig'] = InterceptorConfig


class LauncherConfig(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('http_share_port',): {
            'inclusive_maximum': 65535,
            'inclusive_minimum': 1,
        },
    }

    @property
    def command_path(self):
       return self.get("command_path")

    @command_path.setter
    def command_path(self, new_value):
       self.command_path = new_value

    @property
    def command_arguments(self):
       return self.get("command_arguments")

    @command_arguments.setter
    def command_arguments(self, new_value):
       self.command_arguments = new_value

    @property
    def start_in(self):
       return self.get("start_in")

    @start_in.setter
    def start_in(self, new_value):
       self.start_in = new_value

    @property
    def interceptor_config(self):
       return self.get("interceptor_config")

    @interceptor_config.setter
    def interceptor_config(self, new_value):
       self.interceptor_config = new_value

    @property
    def do_intercept(self):
       return self.get("do_intercept")

    @do_intercept.setter
    def do_intercept(self, new_value):
       self.do_intercept = new_value

    @property
    def http_share_port(self):
       return self.get("http_share_port")

    @http_share_port.setter
    def http_share_port(self, new_value):
       self.http_share_port = new_value

    @property
    def hide_console(self):
       return self.get("hide_console")

    @hide_console.setter
    def hide_console(self, new_value):
       self.hide_console = new_value

    @property
    def disable_http_proxy(self):
       return self.get("disable_http_proxy")

    @disable_http_proxy.setter
    def disable_http_proxy(self, new_value):
       self.disable_http_proxy = new_value

    @property
    def run_as_admin(self):
       return self.get("run_as_admin")

    @run_as_admin.setter
    def run_as_admin(self, new_value):
       self.run_as_admin = new_value

    @property
    def extra_processes(self):
       return self.get("extra_processes")

    @extra_processes.setter
    def extra_processes(self, new_value):
       self.extra_processes = new_value

    @property
    def end_existing_if_running(self):
       return self.get("end_existing_if_running")

    @end_existing_if_running.setter
    def end_existing_if_running(self, new_value):
       self.end_existing_if_running = new_value

    @property
    def wait_for_all_descendants(self):
       return self.get("wait_for_all_descendants")

    @wait_for_all_descendants.setter
    def wait_for_all_descendants(self, new_value):
       self.wait_for_all_descendants = new_value

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'command_path': (str,),  # noqa: E501
            'command_arguments': (str,),  # noqa: E501
            'start_in': (str,),  # noqa: E501
            'interceptor_config': (InterceptorConfig,),  # noqa: E501
            'do_intercept': (bool,),  # noqa: E501
            'http_share_port': (int,),  # noqa: E501
            'hide_console': (bool,),  # noqa: E501
            'disable_http_proxy': (bool,),  # noqa: E501
            'run_as_admin': (bool,),  # noqa: E501
            'extra_processes': ([ExtraProcess],),  # noqa: E501
            'end_existing_if_running': (bool,),  # noqa: E501
            'wait_for_all_descendants': (bool,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None



    attribute_map = {
        'command_path': 'command_path',  # noqa: E501
        'command_arguments': 'command_arguments',  # noqa: E501
        'start_in': 'start_in',  # noqa: E501
        'interceptor_config': 'interceptor_config',  # noqa: E501
        'do_intercept': 'do_intercept',  # noqa: E501
        'http_share_port': 'http_share_port',  # noqa: E501
        'hide_console': 'hide_console',  # noqa: E501
        'disable_http_proxy': 'disable_http_proxy',  # noqa: E501
        'run_as_admin': 'run_as_admin',  # noqa: E501
        'extra_processes': 'extra_processes',  # noqa: E501
        'end_existing_if_running': 'end_existing_if_running',  # noqa: E501
        'wait_for_all_descendants': 'wait_for_all_descendants',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """LauncherConfig - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            command_path (str): The application full path and name, located on the host computer.. [optional]  # noqa: E501
            command_arguments (str): The arguments necessary for the command to run.. [optional]  # noqa: E501
            start_in (str): The launcher start directory. [optional]  # noqa: E501
            interceptor_config (InterceptorConfig): [optional]  # noqa: E501
            do_intercept (bool): If the launcher command requires the use of an interceptor.. [optional] if omitted the server will use the default value of True  # noqa: E501
            http_share_port (int): If configured the launcher will provide local http access to shares attached to this launcher. They will be made available at http://localhost:<port>/org-id/share-name. . [optional]  # noqa: E501
            hide_console (bool): If proxify should use \"--no-console\". [optional] if omitted the server will use the default value of False  # noqa: E501
            disable_http_proxy (bool): If proxify should disable the default http_proxy. This controls the proxify command invocation of \"--no-http-proxy\" . [optional] if omitted the server will use the default value of False  # noqa: E501
            run_as_admin (bool): When true, the launcher will run elevated as administrator. . [optional]  # noqa: E501
            extra_processes ([ExtraProcess]): A set of out of process tasks which will be attached by the interceptor that are not part of the program's process tree. Eg: - Background services - Side-processes started using a messaging protocol . [optional]  # noqa: E501
            end_existing_if_running (bool): When true, allows ending the existing running program during a launch . [optional] if omitted the server will use the default value of False  # noqa: E501
            wait_for_all_descendants (bool): When true in non-interception mode, the launcher continues to run until all descendants of the spawned process have terminated. Use this if the launched application is itself a launcher for something else -- i.e. it spawns the main application then exits. In such cases, you want the launcher to continue to run so that it can proxy requests for the main application and any of its descendants. . [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    def __python_set(val):
        return set(val)
 
    required_properties = __python_set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """LauncherConfig - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            command_path (str): The application full path and name, located on the host computer.. [optional]  # noqa: E501
            command_arguments (str): The arguments necessary for the command to run.. [optional]  # noqa: E501
            start_in (str): The launcher start directory. [optional]  # noqa: E501
            interceptor_config (InterceptorConfig): [optional]  # noqa: E501
            do_intercept (bool): If the launcher command requires the use of an interceptor.. [optional] if omitted the server will use the default value of True  # noqa: E501
            http_share_port (int): If configured the launcher will provide local http access to shares attached to this launcher. They will be made available at http://localhost:<port>/org-id/share-name. . [optional]  # noqa: E501
            hide_console (bool): If proxify should use \"--no-console\". [optional] if omitted the server will use the default value of False  # noqa: E501
            disable_http_proxy (bool): If proxify should disable the default http_proxy. This controls the proxify command invocation of \"--no-http-proxy\" . [optional] if omitted the server will use the default value of False  # noqa: E501
            run_as_admin (bool): When true, the launcher will run elevated as administrator. . [optional]  # noqa: E501
            extra_processes ([ExtraProcess]): A set of out of process tasks which will be attached by the interceptor that are not part of the program's process tree. Eg: - Background services - Side-processes started using a messaging protocol . [optional]  # noqa: E501
            end_existing_if_running (bool): When true, allows ending the existing running program during a launch . [optional] if omitted the server will use the default value of False  # noqa: E501
            wait_for_all_descendants (bool): When true in non-interception mode, the launcher continues to run until all descendants of the spawned process have terminated. Use this if the launched application is itself a launcher for something else -- i.e. it spawns the main application then exits. In such cases, you want the launcher to continue to run so that it can proxy requests for the main application and any of its descendants. . [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")

